/* $Id: bezier.java,v 1.28 2017/04/10 06:22:11 mit3 Exp $ */
/* v0.2 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class bezier extends Applet
    implements MouseListener, MouseMotionListener,
	       ActionListener, ItemListener, AdjustmentListener
{
    private Button[] btGraph;
    private Button btCPlus;
    private Button btCMinus;
    private Button btBPlus;
    private Button btBMinus;
    private Button btAbs;
    private Button btRev;
    private Button btType;
    private List lstInterval;
    private Scrollbar scrWound;
    private Scrollbar scrA49i;
    private Scrollbar scrGrade;
    private Scrollbar scrBassGrade;
    private Label lbWound;
    private Label lbA49i;
    private Label lbGrade;
    private Label lbBassGrade;
    private TextField tfData;
    private Panel PN, PE, PW, PS;
    private Canvas can;
    private Graphics gi;
    private Image ig;

    private final int KB = 88;
    private final int OCTAVE = 12;
    private final int CENT12 = 1200;

    private final int INHA = 0;
    private final int CENT = 1;
    private final int BEAT = 2;
    private final int BEZI = 3;

    private final int PARTIAL = 21; // maxColor
    private final double REVOCT = 1.0/OCTAVE;
    private final String[] Graph = {"Inha.", "Cent", "Beat", "Bezier"};
    private final String[] Octnm = {"A2","A1","A","a","a1","a2","a3","a4"};
    private final String[] KeyName =
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    private static final long serialVersionUID = 1L;

    private int W, H, H2, W2;
    private int DOT, SFT;
    private int DOT0;
    private int FNT;
    private int GRAP = INHA;
    private int WOUND = 28;
    private int Cmax = 80;
    private int Bmax = 10;
    private int KEY = 49-1;
    private double DX, DY;
    private double A49i = 0.55;
    private double Grade = 0.087;
    private double BassGrade = 0.06;
    private boolean AbsSW;
    private boolean RevSW;
    private boolean TypeSW;
    private boolean MouseSW;

    private double[] Cent = new double[KB];
    private double[] Inha = new double[KB];
    private boolean[] Near = new boolean[7];
    private IP[] P = new IP[7];
    private Color[] GC;

    private Font Fnt;
    private FontMetrics fm;
    private DecimalFormat df1;
    private Interval I;

    class IP {
	private double x;
	private double y;
	public IP() {}
	public IP(double a, double b) {
	    x = a;
	    y = b;
	}
    }
    //
    public void init() {
	I = new Interval();
	df1 = new DecimalFormat("#0.0##");
	buildLayout();

	P[0] = new IP(0, -20); // key#(0~87):cent
	P[1] = new IP(10, -1);
	P[2] = new IP(38, -1);
	P[3] = new IP(48, 0);
	P[4] = new IP(58, 1);
	P[5] = new IP(77, 1);
	P[6] = new IP(87, 15);

	initColor();
	initInha(TypeSW);
	initBezier();
    }
    public void start() {
        W = getCanvasD().width;
        H = getCanvasD().height;
	H2 = H/2;
	W2 = W/2;
	DOT = 8;
	SFT = DOT/2;
	DX = (double)W/KB;
	initDot();

	can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
        Dimension de = PE.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(ds.height+dn.height);
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void buildLayout() {
        String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
        setFont(Fnt);
        fm = getFontMetrics(Fnt);

        setLayout(new BorderLayout());

	PN = new Panel();
	PN.setLayout(new FlowLayout());
        add(PN, "North");

	int num = Graph.length;
	btGraph = new Button[num];
        for (int i = 0; i < num; i++) {
            btGraph[i] = new Button(Graph[i]);
            btGraph[i].addActionListener(this);
            PN.add(btGraph[i]);
        }

	tfData = new TextField(24);
        tfData.setEditable(false);
        PN.add(tfData);

	btType = new Button(" Curved ");
        btType.addActionListener(this);
        PN.add(btType);
	//
        PE = new Panel();
        PE.setLayout(new GridLayout(4,1,0,0));
        add(PE, "East");

        btCPlus = new Button("C+");
        btCPlus.addActionListener(this);
        PE.add(btCPlus);

        btCMinus = new Button("C-");
        btCMinus.addActionListener(this);
        PE.add(btCMinus);

	btAbs = new Button("abs.");
        btAbs.addActionListener(this);
        PE.add(btAbs);

	btRev = new Button("->");
        btRev.addActionListener(this);
        PE.add(btRev);
	//
	PW = new Panel();
        PW.setLayout(new GridLayout(4,1,0,0));
        add(PW, "West");

	btBPlus = new Button("B+");
        btBPlus.addActionListener(this);
        PW.add(btBPlus);

        btBMinus = new Button("B-");
        btBMinus.addActionListener(this);
        PW.add(btBMinus);
	//
        PS = new Panel();
	PS.setLayout(new GridLayout(1,3,0,0));
        add(PS, "South");

	Panel s0 = new Panel();
	s0.setLayout(new GridLayout(4,1,0,0));
	PS.add(s0);

	Panel s2 = new Panel();
	s2.setLayout(new GridLayout(4,1,0,0));
	PS.add(s2);

	Panel s1 = new Panel();
	s1.setLayout(new GridLayout(1,1,0,0));
	PS.add(s1);

	int n = I.getInum();
        lstInterval = new List(5, true);
        for (int i = 0; i < n; i++) {
            lstInterval.add(I.toString(i));
        }
        lstInterval.select(5);  // 4th
        lstInterval.select(7);  // 5th
        lstInterval.select(12); // octave
        lstInterval.select(17); // 2octave
        lstInterval.addItemListener(this);
        s1.add(lstInterval);

	scrWound = new Scrollbar(Scrollbar.HORIZONTAL,28,1,0,49);
        s0.add(scrWound);
        scrWound.setBlockIncrement(10);
        scrWound.addAdjustmentListener(this);

	lbWound = new Label("WoundW:28", Label.LEFT);
        s2.add(lbWound);

        scrA49i = new Scrollbar(Scrollbar.HORIZONTAL,55,1,1,110);
        s0.add(scrA49i);
        scrA49i.setBlockIncrement(10);
        scrA49i.addAdjustmentListener(this);

        lbA49i = new Label("A49I:0.55", Label.LEFT);
        s2.add(lbA49i);

	scrGrade = new Scrollbar(Scrollbar.HORIZONTAL,87,1,01,110);
        s0.add(scrGrade);
        scrGrade.setBlockIncrement(10);
        scrGrade.addAdjustmentListener(this);

	lbGrade = new Label("Grade:0.87", Label.LEFT);
        s2.add(lbGrade);

	scrBassGrade = new Scrollbar(Scrollbar.HORIZONTAL,60,1,01,110);
        s0.add(scrBassGrade);
        scrBassGrade.setBlockIncrement(10);
        scrBassGrade.addAdjustmentListener(this);

	lbBassGrade = new Label("BassGrade:0.06", Label.LEFT);
	s2.add(lbBassGrade);
	//
        can = new MyCanvas();
        add(can, "Center");

        can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    //
    public void initDot() {
	DOT = (int)((double)W/KB);
	if (DOT < 2)
	    DOT = 2;
	DOT0 = DOT*2;
	SFT = DOT/2;
    }
    public void initColor() {
        GC = new Color[PARTIAL];
        double dc = 1.0/PARTIAL;
        float c0;
        for (int i = 0; i < PARTIAL; i++) {
            c0 = (float)(dc*i);
            GC[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
        }
    }
    public IP[] initBezier() {
	IP[] p0 = {P[0], P[1], P[2], P[3]};
	IP[] p1 = {P[3], P[4], P[5], P[6]};
	IP[] Px = new IP[KB];

	IP[] Po = calcBezier(p0, 49);
	for (int j = 0; j < Po.length; j++) {
	    Px[j] = Po[j];
	    Cent[j] = Px[j].y;
	}

	Po = calcBezier(p1, 39);
	for (int j = 0; j < Po.length; j++) {
	    Px[j+49] = Po[j];
	    Cent[j+49] = Px[j+49].y;
	}

	return Px;
    }
    public IP[] calcBezier(IP[] po, int len) {
	IP[] p = new IP[len];
	double x, y, i0, i1, di = 1.0/len;

	for (int i = 0; i < len; i++) {
	    i0 = di+i*di;
	    i1 = 1-i0;
	    x = Math.pow(i1,3)*po[0].x + 3*Math.pow(i1,2)*i0*po[1].x +
	    3*i1*Math.pow(i0,2)*po[2].x + Math.pow(i0,3)*po[3].x;

	    y = Math.pow(i1,3)*po[0].y + 3*Math.pow(i1,2)*i0*po[1].y +
	    3*i1*Math.pow(i0,2)*po[2].y + Math.pow(i0,3)*po[3].y;

	    p[i] = new IP(x, y);
	}
	return p;
    }
    public void initInha(boolean sw) {
	int A49 = 48; // 49-1
        double df, sft = 0;
        double[] bass = new double[WOUND+1];
        int ww = WOUND-1; // (0~47)-1
	boolean Itype = sw; //false;

        if (Itype) { // straight
            for (int i = WOUND; i < KB; i++)
                Inha[i] = Math.exp(Grade*i);
            df = A49i/Inha[A49];
            for (int i = WOUND; i < KB; i++)
                Inha[i] *= df;

            if (ww >= 0) { // -1ʤ鴬ʤ
                sft = Inha[WOUND]; // -1
                for (int i = 0; i < WOUND+1; i++) // ޤǺ
		    bass[i] = 1.0/Math.exp(BassGrade*i);
                df = bass[WOUND]/sft;
                for (int i = 0; i < WOUND; i++) // -1ޤǤǹ
                    Inha[i] = bass[i]/df;
	    }
        } else { // curve
            for (int i = WOUND; i < KB; i++)
		Inha[i] = cosh(Grade*(i-WOUND));
            df = A49i/Inha[A49];
            for (int i = WOUND; i < KB; i++)
                Inha[i] *= df;

	    sft = Inha[WOUND];
	    for (int i = 0; i < WOUND+1; i++) // ޤǺ
		bass[i] = cosh(BassGrade*(i-WOUND));
	    df = bass[WOUND]/sft;
	    for (int i = 0; i < WOUND; i++)
		Inha[i] = bass[i]/df;
        }
    }
    public double cosh(double x) {
        double me = Math.pow(Math.E, x);

        return (me+1/me)/2;
    }
    //
    public void mouseMoved(MouseEvent m) {
	if (GRAP != BEZI && MouseSW) {
	    KEY = (int)(m.getX()/DX);
	    can.repaint();
	}
    }
    public void mousePressed(MouseEvent m) {
	//showStatus( mX2key(m.getX())+" : "+(int)mY2cent(m.getY()) );
	if (GRAP == BEZI) {
	    for (int i = 0; i < Near.length; i++) {
		if (i == 3)
		    continue;

		if ( P[i].x > mX2key(m.getX())-3 &&
		     P[i].x < mX2key(m.getX())+3 &&
		     P[i].y > mY2cent(m.getY())-DOT &&
		     P[i].y < mY2cent(m.getY())+DOT ){
		    Near[i] = true;
		}
	    }
	} else {
	    MouseSW = !MouseSW;
	    can.repaint();
	}
    }
    public double mX2key(int m) {
	return m/DX;
    }
    public double mY2cent(int m) {
	return Cmax*(0.5-m/(double)H);
    }
    public void mouseReleased(MouseEvent m) {
	for (int i = 0; i < Near.length; i++) {
	    if (i == 3)
		continue;
	    if (Near[i] == true)
		Near[i] = false;
	}
    }
    public void mouseDragged(MouseEvent m) {
	for (int i = 0; i < Near.length; i++) {
	    if (i == 3)
		continue;
	    if (Near[i] == true) {
		if (i == 0 || i == 6)
		    P[i] = new IP(P[i].x, mY2cent(m.getY()));
		else
		    P[i] = new IP(mX2key(m.getX()), mY2cent(m.getY()));
	    }
	}
	can.repaint();
    }
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void mouseClicked(MouseEvent m) {}
    //
    public void actionPerformed(ActionEvent e) {
        for (int i = 0; i < Graph.length; i++) {
            if (e.getSource() == btGraph[i]) {
                GRAP = i;
		break;
            }
        }
        if (e.getSource() == btCPlus)
            set_Cgain(true);
        else if (e.getSource() == btCMinus)
            set_Cgain(false);

        if (e.getSource() == btBPlus)
            set_Bgain(true);
        else if (e.getSource() == btBMinus)
            set_Bgain(false);

	else if (e.getSource() == btAbs)
	    set_abs();

	else if (e.getSource() == btRev)
	    set_rev();

	else if (e.getSource() == btType)
	    set_type();

	can.repaint();
    }
    public void set_abs() {
	AbsSW = !AbsSW;
	btAbs.setLabel(AbsSW ? "Abs." : "abs.");
    }
    public void set_rev() {
	RevSW = !RevSW;
	btRev.setLabel(RevSW ? "<-" : "->");
    }
    public void set_type() {
	TypeSW = !TypeSW;
	initInha(TypeSW);
	btType.setLabel(TypeSW ? "Straight" : " Curved ");
    }
    public void set_Cgain(boolean sw) {
	Cmax = sw ? Cmax*2 : Cmax/2;
	if (Cmax < 5)
	    Cmax = 5;
    }
    public void set_Bgain(boolean sw) {
	Bmax = sw ? Bmax*2 : Bmax/2;
	if (Bmax < 1)
	    Bmax = 1;	
    }
    public void itemStateChanged(ItemEvent e) { // list
	can.repaint();
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrWound)
            set_wound_wire();
	if (e.getSource() == scrA49i)
            set_a49_inha();
	if (e.getSource() == scrGrade)
            set_grade();
	if (e.getSource() == scrBassGrade)
	    set_bass_grade();

	initInha(TypeSW);
	can.repaint();
    }
    public void set_wound_wire() {
        int ww = scrWound.getValue();
        lbWound.setText("WoundW:"+ww);
	WOUND = ww;
    }
    public void set_a49_inha() {
        double a49 = scrA49i.getValue()/100.0;
        lbA49i.setText("A49I:"+(float)a49);
	A49i = a49;
    }
    public void set_grade() {
        double gr = scrGrade.getValue()/1000.0;
        lbGrade.setText("Grade:"+(float)gr);
	Grade = gr;
    }
    public void set_bass_grade() {
	double gr = scrBassGrade.getValue()/1000.0;
        lbBassGrade.setText("BassGrade:"+(float)gr);
	BassGrade = gr;
    }
    //
    class MyCanvas extends Canvas {
        private static final long serialVersionUID = 1L;
        public void update(Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void backBlack(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    public void paintI() {
	backBlack(gi);
	DY = (double)H/Cmax;

	switch (GRAP) {
        case INHA:
	    dispInha(gi);
	    break;
	case CENT:
	    dispCline(gi);
	    dispAline(gi);
	    dispCentLine(gi);

	    dispCent(gi);
	    //dispDot(gi); /* ɬפ˱ */
	    break;
	case BEAT:
	    dispBline(gi);
	    dispAline(gi);

	    dispBeats(gi);
	    break;
	case BEZI:
	    dispCline(gi);
	    dispBline(gi);
	    dispAline(gi);
	    dispCentLine(gi);

	    dispBeats(gi);
	    dispDot(gi);
	    dispBezier(gi);
	    break;
	default:
	    break;
	}

	write_tfdata();
    }
    public void write_tfdata() {
        StringBuffer sb = new StringBuffer(40);
        sb.append(getKeyname(KEY)+":");
        sb.append(dform(calcFreq(1, KEY))+"[Hz]");

        switch (GRAP) {
        case INHA:
            sb.append(":"+dform(Inha[KEY]));
            break;
        case CENT:
	case BEZI:
            sb.append(":"+dform(Cent[KEY]));
            sb.append("[cent]");
            break;
        case BEAT:
            //
            break;
        default:
        }

        tfData.setText(sb.toString());
    }
    public String getKeyname(int num) {
        return (num+1)+"("+getKey(num)+")";
    }
    public String getKey(int key) {
        return (key < 0) ? "" : KeyName[key%OCTAVE];
    }
    //
    public void dispDot(Graphics g) {
	int x, y;

	g.setColor(Color.green);
	for (int i = 0; i < P.length; i++) {
	    x = (int)(P[i].x*DX-SFT);
	    y = (int)(H2-P[i].y*DY-SFT);
	    g.fillOval(x, y, DOT0, DOT0);
	}
    }
    //
    public void dispCline(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);
    }
    public void dispBezier(Graphics g) {
	int x, y;
	IP[] Px = initBezier();

	g.setColor(Color.white);
	for (int i = 0; i < Px.length; i++) {
	    x = (int)(Px[i].x*DX);
	    y = (int)(H2-Px[i].y*DY);
	    g.fillOval(x, y, DOT, DOT);
	}
    }
    public void dispCentLine(Graphics g) {
        int hp, hm, len;
	String str;
        double hy, hi, hx = Cmax/10.0;

        for (int i = 1; i < 6; i++) {
            hi = hx*i;
            hy = hi*DY;
            hp = (int)(SFT+H2+hy);
            hm = (int)(SFT+H2-hy);

            g.setColor(Color.darkGray);
            g.drawLine(0, hm, W, hm);
            g.drawLine(0, hp, W, hp);

            g.setColor(Color.pink);
	    str = dform(hi);
	    len = fm.stringWidth(str);
            g.drawString(str, W-len, hm+FNT);
	    str = "-"+str;
	    len = fm.stringWidth(str);
            g.drawString(str, W-len, hp);
        }
    }
    //
    public int[] get_interval_list() {
        return lstInterval.getSelectedIndexes();
    }
    public void dispBeats(Graphics g) {
	int num, max;
	int[] inter = get_interval_list();
	double val;
	double db = AbsSW ? (double)H/Bmax : (double)H2/Bmax;
	int hh = AbsSW ? H : H2;
	Color mc;

	for (int j = 0; j < inter.length; j++) {
	    num = inter[j];
	    max = I.getIvalue(num); // 
	    mc = GC[num];
	    disp_beat_text(g, num, mc, j);

	    for (int i = 0; i < KB; i++) {
		setColor(g, i, mc);
		if (RevSW) {
		    if (i < max)
			continue;
		    val = getMbeats(i, -num, 1);
		} else {
		    if (i >= KB-max)
			break;
		    val = getMbeats(i, num, 1);
		}
		val = AbsSW ? Math.abs(val) : val;
		g.fillOval((int)(i*DX), (int)(hh-val*db), DOT, DOT);

		if (i == KEY) {
		    g.setColor(Color.white);
		    g.drawString(dform(val), W2+4, FNT*(j+1));
		}
	    }
	}
    }
    public void setColor(Graphics g, int key, Color co) {
	if (key == KEY)
	    g.setColor(Color.white);
	else
	    g.setColor(co);
    }
    public void disp_beat_text(Graphics g, int n, Color c, int j) {
        String str = I.toString(n);
        int w0 = fm.stringWidth(str);
        g.setColor(c);
        g.drawString(str, W2-w0, FNT*(j+1));
    }
    public void dispBline(Graphics g) {
	if (!AbsSW)
	    dispCline(g);

	int hp = 0, hm, max = 5, xs = 2;
        int h2 = (AbsSW) ? H : H2;
        double hi, hv;
        double db = Bmax/(double)max;
        double dh = h2/(double)max;

        for (int i = 1; i < 6; i++) {
            hv = i*db;
            hi = i*dh;
            hm = (int)(SFT+h2-hi);
            if (!AbsSW)
                hp = (int)(SFT+h2+hi);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);
            if (!AbsSW)
                g.drawLine(0, hp, W, hp);

            g.setColor(Color.yellow);
            g.drawString(dform(hv), xs+2, hm+FNT);
            if (!AbsSW)
                g.drawString("-"+dform(hv), xs, hp);
        }
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public double getMbeats(int key, int inte, int mul) {
        int[] ratio = I.getIdata(inte); // -б
        int keyh = key+ratio[2];

        return get_mbeats(keyh, key, ratio, mul);
    }
    public double get_mbeats(int keyh, int keyl, int[] ratio, int mul) {
        return get_ibeats(keyh, keyl, calc_multi(ratio, mul));
    }
    public double get_ibeats(int keyh, int keyl, int[] ratio) {
        double fh = calcFreq(ratio[1], keyh);
        double fl = calcFreq(ratio[0], keyl);

        return (fh-fl);
    }
    public int[] calc_multi(int[] ratio, int mul) {
        int[] rat = new int[3];

        if (mul < 1) {
            System.out.println("*** Multi input error. ***");
            mul = 1;
        }
        rat[0] = ratio[0]*mul; // low
        rat[1] = ratio[1]*mul; // hi
        rat[2] = ratio[2];

        return rat;
    }
    public double calcFreq(int par, int key) {
        return ctof(getFreq(key)*par, getICent(key, par));
    }
    public double ctof(double f, double c) {
        return f*Math.pow(2, c/CENT12);
    }
    public double getFreq(int key) {
        return 440*Math.pow(2, (key-48)*REVOCT); // 49-1
    }
    public double getICent(int key, int par) {
	return Inha[key]*par*par+Cent[key];
    }
    //
    public void dispInha(Graphics g) {
	dispAline(g);
	dispInhaLine(g);

        for (int i = 0; i < KB; i++) {
	    setWireColor(g, i);
            g.fillOval((int)(i*DX),
		       (int)calc_inha(Inha[i]), DOT, DOT);
        }
    }
    public void setWireColor(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else if (key < WOUND)
	    g.setColor(Color.pink);
	else
	    g.setColor(Color.white);
    }
    public double calc_inha(double val) {
        return H2-Math.log(val)*H/10.0;
    }
    public void dispInhaLine(Graphics g) {
        double h0 = 0.001, hl;
	double di = H/5.0;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
	    hm = (int)(SFT+H2-log_base(hl)*di);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public double log_base(double value) {
        return Math.log(value)/Math.log(10);
    }
    public void dispAline(Graphics g) {
        int x;

        for (int i = 0; i < KB; i += OCTAVE) {
            x = (int)(SFT+DX*i);

            g.setColor(Color.blue);
            g.drawLine(x, 0, x, H);

            g.setColor(Color.red); // octav name
            g.drawString(Octnm[i/OCTAVE], x, H-FNT);
        }
    }
    //
    public void dispCent(Graphics g) {
	initBezier();

        for (int i = 0; i < KB; i++) {
	    setCentColor(g, i);
	    g.fillOval((int)(i*DX), (int)(H2-Cent[i]*DY), DOT, DOT);
	}
    }
    public void setCentColor(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.green);
	else
	    g.setColor(Color.yellow);
    }
}
